# $Id: language.py,v 1.28 1996/07/18 13:52:38 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import string
import pickle
import komhtml

anchor = komhtml.anchor

# Set by sc.  This module uses toolbar.at_top() and toolbar.at_bottom()
# to extract the tool bar.
toolbar = None

TEXT_FORMAT = """%(text_no)d %(creation_date)s /%(lines)s/ %(author)s<br>
%(recipients)s%(uplinks)s%(marks)s
<h3>rende: %(subject)s</h3>

%(body)s

<p>%(footnotes)s%(comments)s
"""

COMMENT_FORMAT = """Kommentera text %(parent_link)s av %(parent_author)s

<p><form action="submit_text" method="get">
<input type="hidden" name="parent" value="%(parent)s">
<input type="hidden" name="known_comments" value="%(known_comments)s">
Konvertering av text:<br>
<input type="radio" name="conversion" 
    value="swascii" %(select_swascii)s>frn swascii<br>
<input type="radio" name="conversion"
    value="none" %(select_none)s>ingen<br>
Mottagare: (ta bort en mottagare frn listan genom att vlja bort den)<br>
<input type="hidden" name="no_of_rcpts" value="%(no_of_rcpts)s">
%(recipients)s

<p><input type="submit" value="Skapa kommentaren">

<p><input type="text" name="subject" value="%(subject)s" size=70>
<textarea name="body" rows="15" cols="70">%(body)s</textarea>

<p><input type="submit" value="Skapa kommentaren">
</form>
"""

WRITE_TEXT_FORMAT = """

<p><form action="submit_text" method=get>
Konvertering av text:<br>
<input type="radio" name="conversion" 
    value="swascii" %(select_swascii)s>frn swascii<br>
<input type="radio" name="conversion"
    value="none" %(select_none)s>ingen<br>
Mottagare: (ta bort en mottagare frn listan genom att vlja bort den)<br>
<input type="hidden" name="no_of_rcpts" value="%(no_of_rcpts)s">
%(recipients)s

<p><input type="submit" value="Skapa texten">

<p><input type="text" name="subject" value="%(subject)s" size=70>
<textarea name="body" rows="15" cols="70">%(body)s</textarea>

<p><input type="submit" value="Skapa texten">
</form>
"""

SET_UNREAD_FORM = """
<form action="set_unread" method=get>
Hr kan du ndra antalet olsta texter i %(name_nolink)s.  Du kan
vlja att bara lsa inlgg som skrivits de senaste dagarna, eller att
bara lsa de senaste inlggen.
<p>
Antal inlgg: <input type="text" name="unread_texts" size=8><br>
Antal dagar: <input type="text" name="unread_days" size=8>
<input type="submit" value="ndra antal olsta">
<input type="hidden" name="conf_no" value="%(conf_no)d">
</form>
"""

NEW_TEXTS_INFO = """\
Sedan du brjade frfatta din kommentar har det skapats minst en
ny kommentar.  gna igenom de nya texterna nedan.  Om du fortfarande
tycker att din kommentar r relevant kan du klicka p
"Skapa kommentaren"-knappen (lngst ner p sidan) fr att skicka in
texten igen.  Om du mrker att ngon annan redan har sagt det du hade
tnkt sga r det kanske ingen strre vits med att du upprepar samma
sak en gng till.  I s fall kan du g tillbaks och fortstta lsa.
<p>

<hr><blockquote>
"""

NEW_TEXTS_INFO_TAIL = "</blockquote><hr>"

KILLED = """\
Din sessionshanterare r nu avslutad.  Du r utloggad ur LysKOM.
Observera dock att din WWW-klient troligtvis fortfarande innehller
ditt LysKOM-anvndarnamn och lsenord.  Fr att skerstlla att
ingen obehrigt anvnder LysKOM i ditt namn br du starta om din
WWW-klient innan du lmnar datorn.

<p>Du kan starta en ny session genom att vlja ngot av alternativen ovan.
"""

SELECT_CONF_FORM = """\
<form action="submit_select_conf" method=get>
Namn: <input type="text" name="conf_name" size=70>
<input type="submit" value="Sk"><br>
Vad ska matchas?<br>
<input type="radio" name="domain" value="conf" checked>Enbart mten<br>
<input type="radio" name="domain" value="pers">Enbart personer<br>
<input type="radio" name="domain" value="both">Bde personer och mten<br>
</form>

<p>I rutan efter "Namn" kan du fylla i ett mtes- eller personnamn.
Du kan frkorta namnet genom att utelmna ord p slutet, och genom att
utelmna bokstver p slutet i ord.  Om mer n ett mte matchar det
frkortade mtesnamnet du angivit kommer du att f upp en lista med
dem, dr du kan vlja rtt.

<p>Om du lmnar rutan tom kommer alla mten att returneras.  Det kan
ta ett bra tag.

<p>Du kan vlja om du vill ska bland mten, personer eller bde och.
"""

CONF_STAT = """\
Status fr mte "%(name)s":

<ul>%(creator)s
<li>Organisatr%(supervisor)s
<li>Tilltna frfattare: %(permitted_submitters)s
<li>Presentation: %(presentation)s
</ul>

%(join_or_member)s<br>
%(write_text_anchor)s<br>
%(set_unread_form)s
"""

class pages:
    def page(self, title, header, body):
	if toolbar:
	    top_tool = toolbar.at_top()
	    bot_tool = toolbar.at_bottom()
	else:
	    top_tool = ""
	    bot_tool = ""
	return ("<html><head><title>" + self.title(title)
		+ "</title></head>\n"
		+ '<body bgcolor="#ffffff" text="#000000"'
		+ ' link="#0000ee" vlink="551a8b" alink="ff0000">\n'
		+ top_tool + "\n<h2>"
		+ header + "</h2>\n\n" + body + bot_tool + "\n\n"
		+ self.stdfoot() + "</body></html>")


class sw_pages(pages):
    def stdfoot(self):
	return ("<hr>"
		+ komhtml.icon("wwwkom.gif", "WWW-koms hemsida", "/")
		+ komhtml.icon("signum.gif", "Signum Support AB",
			       "http://www.signum.se/")
		+ 'WWW-kom. Copyright (C) 1996 Signum Support AB\n')

    def title(self, t):
	return "LysKOM: " + t

    def ambiguous_login(self, given, matches):
	res="<ul>\n"
	for m in matches:
	    res = res + '<li>' + anchor(komhtml.komurl("login", m.conf_no()),
					komhtml.htmlquote(m.conf_name()))
	res = res + "</ul>\n\n"
	return self.page("Vem r du?", "Vem r du?",
			 "Det namn du angav, \"" + komhtml.htmlquote(given)
			 + "\", kan vara ngon av fljande personer:\n"
			 + res)

    def bad_cookie_support(self):
	# This is currently not used.
	return self.page("Cookie-fel", "Cookie borttappad",
			 "WWW-kom anvnder sig av "
			 + '<a href="http://search.netscape.com'
			 + '/newsref/std/cookie_spec.html">'
			 + "HTTP Cookies</a>\n"
			 + "fr att hlla reda p vilken ordning du ska "
			 + "lsa texter i.\n"
			 + "Din klient verkar ha tappat bort en cookie.\n"
			 + "WWW-kom har just frskt att stta den igen.\n"
			 + "<ul><li>Om din browser stder cookies kan du "
			 + anchor(komhtml.komurl("default_cmd"),
				  "fortstta lsa")
			 + " p ungefr det stlle du slutade.\n"
			 + "<li>Om din browser inte stder cookies kan du "
			 + "tyvrr inte anvnda\n"
			 + komhtml.iconref("next.gif",
					   "nsta text/fotnot/mte/etc")
			 + "-ikonen.  Sorry.\n"
			 + "Du br kunna lsa KOM nd genom att flja lnkar"
			 + "manuellt, men du br skaffa en bttre browser.\n"
			 + "</ul>\n"
			 + "Om du inte vet om din browser stder cookies "
			 + "r det bara att prova lnken ovan.\n"
			 + "Om din browser inte stder cookies kommer du "
			 + "att komma tillbaks till den hr sidan.\n")

    def bad_password_for_session(self, given_user):
	return self.page("Fel lsen", "Felaktigt lsenord",
			 "Det lsenord du angav stmmer inte med "
			 + "lsenordet fr "
			 + given_user + '.  '
			 + anchor(komhtml.komurl("login"), "Frsk igen."))

    def nonexisting_person_url(self, given_number):
	return self.page("Felaktig URL", "Felaktig URL",
			 "Du har fljt en lnk som innehller en referens till"
			 + " person nummer " + `given_number`
			 + ". Det finns fr tillfllet ingen sdan anvndare. "
			 + anchor(komhtml.komurl("login"), "Frsk igen."))

    def noconnect(self):
	return self.page("Servern svarar inte", "LysKOM-servern svarar inte",
			 "LysKOM-servern kan inte ns.  Det kan bero p att "
			 + "servern r nere eller ngot ntverksproblem.  "
			 + "Frsk igen om en halvtimme.")

    def session_redirect(self, newurl):
	return self.page("Omstyrning", "Omstyrning",
			 "Din WWW-klient tycks inte frst felkod 301. Det "
			 + "innebr troligtvis att du inte kan anvnda den "
			 + "fr att lsa LysKOM med WWW-kom, men om du har "
			 + "tur kanske du kan anvnda WWW-kom genom att "
			 + anchor(newurl, "flja denna lnk"))

    def who_is_on(self, wholist):
	header = "<table border=0 cellpadding=3>"
	footer = "</table><p><h3>Sammanlagt " + `len(wholist)` \
		 + " personer</h3>"

	wholiststring = string.join(wholist, "\n")
	return self.page("Inloggade i lyskom",
			 "Fljande personer r inloggade fr nrvarande",
			 header + wholiststring + footer)

    def who_is_on_conf(self, conf, wholist):
	header = ("Fljande personer r just nu nrvarande i "
		  + conf + "\n\n<table border=0 cellpadding=3>")
	footer = "</table><p><h3>Sammanlagt " + `len(wholist)` \
		 + " personer</h3>"

	wholiststring = string.join(wholist, "\n")
	return self.page("Nrvarande i mte",
			 "Nrvarande i mte",
			 header + wholiststring + footer)

    def not_present(self):
	return "Ej nrvarande i ngot mte"

    def format_footnote(self, footnote, footnote_author):
	return ("Fotnot i text " + footnote + " av " + footnote_author
		+ "<br>\n")

    def format_comment(self, comment, comment_author):
	return ("Kommentar i text " + comment + " av " + comment_author
		+ "<br>\n")

    def format_date(self, date):
	return "%04d-%02d-%02d %02d:%02d:%02d" % date[0:6]
	return `date[0]` + "-" + `date[1]` + "-" + `date[2]` \
	       + " " + `date[3]` + ":" + `date[4]` + ":" + `date[5]`

    def format_uplink(self, is_footnote, parent_text, parent_author_name,
		      sent_at, sender_name):
	if is_footnote:
	    res = "Fotnot till text "
	else:
	    res = "Kommentar till text "
	res = res + parent_text + " av " + parent_author_name + "<br>\n"
	if sent_at:
	    res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_at)
		   + "<br>\n")
	if sender_name:
	    res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
	return res

    def undef_conf(self, conf_no):
	return "Person/mte nummer " + `conf_no` + " (existerar ej/hemlig)"

    def nonexisting_text(self):
	return " (ej lsbar av dig)"

    def nonexisting_text_long(self):
	return "Texten finns inte, eller ocks r den hemlig."

    def anonymous_author(self):
	return " (anonym frfattare)"

    def nonexistent_author(self, pers_no):
	return " (utplnad/hemlig frfattare nummer " + `pers_no` + ")"

    def format_recipient(self, is_carbon_copy, name, local_no,
			 rec_time, sent_time, sender_name):
	if is_carbon_copy:
	    res = "Extra kopiemottagare "
	else:
	    res = "Mottagare "
	res = res + name + " &lt;" + `local_no` + "&gt;<br>\n"
	if rec_time:
	    res = (res + "&nbsp;&nbsp;Mottaget: " + self.format_date(rec_time)
		   + "<br>\n")
	if sent_time:
	    res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_time)
		   + "<br>\n")
	if sender_name:
	    res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
	return res

    def text_rewrite_map(self, map):
	if map["lines"] == 1:
	    map["lines"] = "1 rad"
	else:
	    map["lines"] = `map["lines"]` + " rader"
	marks = map["num_marks"]
	if marks == 0:
	    map["marks"] = ""
	elif marks == 1:
	    map["marks"] = "Markerad av en person<br>\n"
	else:
	    map["marks"] = "Markerad av " + `marks` + " personer<br>\n"

	# FIXME
	map["default_url"] = "<i>Default-URL</i>"


    def alt_conf(self):
	return "Olsta i mtet"

    def explain_conf(self):
	return "Lista olsta inlgg i mtet"

    def alt_comment(self):
	return "Kommentera"

    def explain_comment(self, textno):
	return "Skriv en kommentar till text " + `textno`

    def alt_write_text(self):
	return "Skriv inlgg"

    def explain_write_text(self):
	return "Skriv inlgg"

    def alt_next_conf(self, cname):
	# FIXME: This might be too long.
	return "Nsta mte (" + cname + ")"

    def explain_next_conf(self, cname):
	return "G till nsta mte (" + cname + ")"

    def alt_see_time(self):
	return "Se tiden"

    def explain_see_time(self):
	return "Se tiden (enligt servern)"

    def alt_home(self):
	return "Hem"

    def explain_home(self):
	return "Lista mten med olsta texter"

    def alt_kill(self):
	return "Logga ut"

    def explain_kill(self):
	return "Avsluta WWW-kom"

    def alt_next_text(self, tno):
	return "Nsta text (" + `tno` + ")"

    def explain_next_text(self, tno):
	return "Lsa nsta text (" + `tno` + ")"

    def alt_next_comment(self, tno):
	return "Nsta kommentar (" + `tno` + ")"

    def explain_next_comment(self, tno):
	return "Lsa nsta kommentar (" + `tno` + ")"

    def alt_next_footnote(self, tno):
	return "Nsta fotnot (" + `tno` + ")"

    def explain_next_footnote(self, tno):
	return "Lsa nsta fotnot (" + `tno` + ")"

    def alt_select_conf(self):
	return "Lista mten"

    def explain_select_conf(self):
	return "Sk efter mte och visa info"

    def format_text(self, map):
	self.text_rewrite_map(map)
	return TEXT_FORMAT % map

    def info_unread_conf(self, conf, unread):
	return `unread` + " olsta i " + conf

    def info_unread_conf_many(self, conf):
	return "Mnga olsta i " + conf

    def there_are_more_unread_confs(self):
	return ("\n<p>\nDu har olsta inlgg i nnu fler mten. "
		+ "De kommer att visas nr du har lst ovanstende mten.")

    def login(self, unreadlist, trunc_msg):
	return self.page("Vlkommen", "Vlkommen till LysKOM!",
			 "Du r nu inloggad. "
			 + "Du har olsta inlgg i fljande mten:\n<p>\n"
			 + unreadlist
			 + trunc_msg)

    def unread_confs(self, unreadlist, trunc_msg):
	return self.page("Olsta mten", "Olsta mten",
			 "Du har olsta inlgg i fljande mten:\n<p>\n"
			 + unreadlist
			 + trunc_msg)

    def text_link(self, texturl, subject, prev_subject, author):
	if subject == prev_subject:
	    return texturl + " " + author
	else:
	    return texturl + " " + subject + "<br>\n" + author

    def different_passwords(self):
	return self.page("WWW-kom", "Kunde inte skapa person",
			 "Du angav tv olika lsenord.  Frsk igen.")

    def person_creation_failed(self, name):
	return self.page("WWW-kom", "Kunde inte skapa person",
			 "En person med namnet " +name+ " kunde inte skapas.\n"
			 + "Kanske finns det redan ngon som heter s?\n\n"
			 + "<p>Frsk igen med ett annat namn.\n"
			 + "Du kan till exempel lgga till en initial "
			 + "eller namnet p din organisation.")

    def creation_done(self, name, pno):
	return self.page("WWW-kom", "Vlkommen",
			 "Vlkommen till LysKOM, " + komhtml.htmlquote(name)
			 + "!\nHoppas du ska trivas hr.\n"
			 + "Nu mste du "
			 + anchor("wwwkom/login", "logga in") + ". "
			 + "Din Web-klient kommer att be dig mata in det namn "
			 + "och lsenord som du just angav.\n"
			 + "(Du tycker kanske att det r dumt att du ska "
			 + "behva mata in de uppgifterna igen.  Tyvrr "
			 + "tvingar HTTP fram den hr lsningen).\n\n"
			 + "<p>Om du r den sifferlskande typen vill du "
			 + "kanske veta att ditt anvndarnummer r " + `pno`
			 + ".  Annars kan du strunta i det -- du kan alltid "
			 + "anvnda ditt namn och behver inte komma ihg det "
			 + "nummer som anvnds internt i LysKOM-systemet.")

    def write_comment(self, map):
	return self.page("Kommentera text " + map["parent"],
			 "Kommentera text " + map["parent"],
			 COMMENT_FORMAT % map)

    def write_text(self, map):
	return self.page("Skriva inlgg",
			 "Skriva inlgg i " + map["conf_name"],
			 WRITE_TEXT_FORMAT % map)

    def write_text_format_recipient(self, conf, conf_as_link, sequence):
	return ('<input type="checkbox" name="rcpt' + `sequence`
		+ '" value="' + `conf` + '" checked> '
		+ conf_as_link + '<br>\n')

    def text_created(self, tno):
	return self.page("Text skapad", "Text " + `tno` + " skapad.",
			 "Text nummer " + komhtml.text_as_link(tno)
			 + " r nu skapad.")

    def new_texts_exists(self, new_texts, map):
	new_texts = string.join(new_texts, "\n<hr>\n")
	return self.page("Kommentera", "Nya kommentarer funna",
			 NEW_TEXTS_INFO + new_texts + NEW_TEXTS_INFO_TAIL
			 + (COMMENT_FORMAT % map))

    def killed(self):
	return self.page("Omstart", "Omstart", KILLED)

    def select_conf_form(self):
	return self.page("Lista mten", "Lista mten", SELECT_CONF_FORM)

    def list_conf(self, matches):
	# FIXME: kan vara personer...
	res="<ul>\n"
	for item in matches:
	    res = (res + '<li>'
		   + komhtml.conf_as_link(item.conf_no(), item.conf_name())
		   + '\n')
	res = res + "</ul>\n\n"
	return self.page("Mten", "Mten",
			 "Fljande mten/personer matchar det du angav: <p>" 
			 + res)

    def conf_stat(self, session, map):
	j = map["join"]
	if map["join"] != None:
	    map["join_or_member"] = anchor(j, "G med i mtet")
	    map["set_unread_form"] = ""
	else:
	    map["join_or_member"] = "Du r medlem i mtet"
	    map["set_unread_form"] = SET_UNREAD_FORM % \
				     {"name_nolink":map["name_nolink"],
				      "conf_no":map["conf_no"]}

	if map["supervisor"] == None:
	    map["supervisor"] = " saknas"
	else:
	    map["supervisor"] = ": " + map["supervisor"]

	if map["creator"] == None:
	    map["creator"] = ""
	else:
	    map["creator"] = "\n<li>Skapat av: " + map["creator"]

	map["write_text_anchor"] = anchor(map["write_text"],
					  "Skriv ett inlgg i mtet")

	return self.page(map["name_nolink"], map["name"], CONF_STAT % map)

lingo=sw_pages()
