# $Id: sc.py,v 1.33 1996/07/18 15:09:19 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import signal
import regsub
import pickle
import string
import base64
import toolbar
import komhtml
import komtext
import myserver
import myhttpbase
import komxx
import sys
import socket
import language
import log
import estring
import os
import time

from language import lingo

session=None
true=1
false=0

system_error='system_error'
internal_error='internal_error'

class State:
    def __init__(self):
	self.password = None		# The correct password

state = State()

class sh(myhttpbase.myhttpbase):

    def send_response(self, code, message=None):
	"As myhttpbase.send_response, but adds an expired Expires field."
	myhttpbase.myhttpbase.send_response(self, code, message)
	self.send_header("Expires", self.date_time_string())
	self.reply_written = 1

    def prepare_request(self):
	global state
	self.reply_written = 0

	self.cookie_fetch()
	# FIXME: Handle async calls when idle, somehow.
	# Requires a new top-loop.
	while session.handle_async(20) == komxx.st_pending:
	    log.debug("Handling even more async...")
	self.url = komhtml.decodeurl(self.path)
	[user, password] = self.retrieve_authorization()
	self.set_cookie(user, session.my_login())

	if self.url.pers_no:
	    self.redirect()

	elif password != state.password:

	    self.clear_cookie()
	    raise komhtml.bad_auth

	# The user is now authenticated.
	if session.my_login() == 0:
	    raise internal_error, "my_login() is 0 after successful login"

	# Initialize toolbar
	self.toolbar = toolbar.toolbar()

	# Transfer the toolbar into the language package.
	language.toolbar = self.toolbar
	komhtml.text_to_mark = None

	# Set up the read-order if it is set in a cookie.
	self.fix_readorder()

	# Perform embedded commands
	read_text = self.url.getnum("is_read")
	if read_text:
	    session.remove_text(read_text)
	    text = session.text(read_text)
	    text.mark_as_read()

    def fix_readorder(self):
	self.user_next_text = None
	self.user_current_conf = None
	self.user_pending_footnotes = []
	self.user_pending_comments = []
	data = self.cookie_read_order()
	log.debug("fix_readorder: got " + `data`)
	if data == None:
	    return
	fields = string.splitfields(data, ":")
	if len(fields) < 3:
	    log.notice("Very short cookie '" + cookie + "' received")
	    return
	try:
	    self.user_current_conf = string.atoi(fields[0])
	    if len(fields[1]) != 0:
		self.user_next_text = string.atoi(fields[1])
	except ValueError:
	    log.notice("Malformed cookie '" + cookie + "' received")
	    return
	self.user_pending_footnotes = self.xlisttoints(fields[2])
	if len(fields) == 4:
	    self.user_pending_comments = self.xlisttoints(fields[3])

	if self.user_next_text != None:
	    if session.goto_conf(self.user_current_conf) == komxx.st_ok:
		log.debug(" Set current conf: " + `session.current_conf()`
			  + " user: " + `self.user_current_conf`)
		log.debug(" Unread texts: " + `session.list_unread_texts_in_current(20)`)
		session.set_pending_footnotes(self.user_pending_footnotes)
		session.set_pending_comments(self.user_pending_comments)
		log.debug(" Unread texts: " + `session.list_unread_texts_in_current(20)`)

    def xlisttoints(self, xlist):
	res = []
	for elem in string.splitfields(xlist, "x")[:-1]:
	    try:
		res.append(string.atoi(elem))
	    except ValueError:
		# Ignore the trail once an error has been detected
		return res
	return res

    def intstoxlist(self, ints):
	res = ""
	for i in ints:
	    res = res + `i` + "x"
	return res

    def do_GET(self):
	self.reply_written = 0
	signal.alarm(600)
	try:
	    try:
		self.prepare_request()
		mname = "kom_GET_" + self.url.cmd
		if not hasattr(self, mname):
		    self.send_error(501)
		    return
		method = getattr(self, mname)
		method(self.url)
	    except komhtml.bad_auth:
		self.bad_auth()
	    except komhtml.not_a_komurl, emsg:
		if emsg != None:
		    self.send_error(500, "not-a-komurl:" + emsg)
		else:
		    self.send_error(500, "not-a-komurl.")
	    except internal_error, str:
		self.send_error(500, "internal_error 1 " + str)
	    # FIXME: a nicer error page, thanks.
	    except komxx.errno_error, err:
		self.send_error(500, "During GET: unhandled LysKOM error "
				+ `err.errno` + " occured: " + err.errmsg)
	except:
	    if self.reply_written == 0:
		log.err("No reply sent to query (exception)")
		self.send_error(500, "Internal error 2: unexpected exception")
		self.wfile.flush()
		if sys.exc_type:
		    import traceback
		    log.debug("Catched exception:"
			      + `sys.exc_type` + `sys.exc_value`
			      + `traceback.format_tb(sys.exc_traceback)`)
	if self.reply_written == 0:
	    log.err("No reply sent to query (normal execution)")
	    self.send_error(500, "Internal error 3")
	    self.wfile.flush()

    def do_POST(self):
	# Note: do_POST is never used and probably contains errors.
	signal.alarm(600)
	try:
	    self.prepare_request()
	    length = self.headers.getheader('Content-length')
	    if (self.headers.getheader('Content-type')
		!= "application/x-www-form-urlencoded"):
		self.log_error("Bad content-type"
			       + self.headers.getheader('Content-type'))
		self.send_error(400)
		return
	    body = self.rfile.read(eval(length))
	    args = komhtml.form_data(body)
	    mname = "kom_POST_" + self.url.cmd
	    if not hasattr(self, mname):
		self.send_error(501)
		return
	    method = getattr(self, mname)
	    method(args)
	except komhtml.bad_auth:
	    self.bad_auth()
	except komhtml.not_a_komurl, emsg:
	    self.send_error(500, "not-a-komurl 2" + emsg)
	except internal_error, str:
	    self.send_error(500, "internal_error 3" + str)
	except komxx.errno_error, err:
	    self.send_error(500, "During POST: unhandled LysKOM error "
			    + `err.errno` + " occured: " + err.errmsg)

    def kom_GET_login(self, args, is_login=1):
	texts_in_conf=50
	confs=20
	while session.prefetch(0, 0, 0,
			       0, texts_in_conf, confs+1,
			       40) == komxx.st_pending:
	    session.block(1000)

	unread_list=session.confs_with_unread()
	trunc=""
	if len(unread_list) > confs:
	    unread_list[-1:]=[]
	    trunc=lingo.there_are_more_unread_confs()
	conflist=[]
	for unread in unread_list:
	    conf=komtext.safe_name_direct_conf(session, unread[0])
	    min_unread=unread[1]
	    max_unread=unread[2]
	    if min_unread == max_unread:
		conflist.append(lingo.info_unread_conf(conf, min_unread))
	    else:
		conflist.append(lingo.info_unread_conf_many(conf))

	if len(unread_list) > 0:
	    # FIXME: this default should probably be according to
	    # the current contents of the readorder cookie.  This is bogus.
	    self.toolbar.add_default_conf(unread_list[0][0],
					  komtext.safe_name_nolink(
		session, unread_list[0][0]))
	else:
	    self.toolbar.add_default_time()

	if is_login:
	    if len(unread_list) > 0:
		self.cookies.append(("LysKOM_www_readorder",
				     `unread_list[0][0]` + ":::"))
	    else:
		self.cookies.append(("LysKOM_www_readorder", ""))

	    self.respond(lingo.login(string.join(conflist, "<br>\n"), trunc))
	else:
	    self.respond(lingo.unread_confs(string.join(conflist, "<br>\n"), 
					    trunc))

    def kom_GET_home(self, args):
	self.kom_GET_login(args, 0)

    def kom_GET_text(self, args):
	tno = args.getnum("text_no")
	if tno == None:
	    raise komhtml.not_a_komurl, "text_no argument missing to /text"
	self.kom_get_text(tno)

    def kom_get_text(self, tno):
	text=session.text(tno)
	try:
	    komhtml.text_to_mark = tno
	    komtext.prefetch_for_display(session, text)
	    map = komtext.map_for_display(session, text)
	    the_page = lingo.format_text(map)
	    self.toolbar.enable_bottom()
	except komxx.err_no_such_text:
	    the_page = lingo.nonexisting_text_long()
	if session.current_conf() != 0:
	    self.toolbar.add_current_conf(session.current_conf())
	self.toolbar.add_comment(tno)
	if session.current_conf() != 0:
	    self.toolbar.add_write(session.current_conf())
	if session.current_conf() != 0:
	    session.enqueue_children(tno)
	session.remove_text(tno)
	self.fix_default(1)
	# FIXME: Swedish!  Be gone!
	self.respond(lingo.page("Text " + `tno`, "Text " + `tno`, the_page))

    def fix_default(self, do_set_cookie = 0):
	if do_set_cookie == 0:
	    # Form the default action depending on what the user said
	    # was the default action, but within certain limits.
	    if self.user_next_text != None:
		if len(self.user_pending_footnotes):
		    self.toolbar.add_default_footnote(self.user_next_text)
		elif len(self.user_pending_comments):
		    self.toolbar.add_default_comment(self.user_next_text)
		else:
		    self.toolbar.add_default_text(self.user_next_text)
		return
	    elif self.user_current_conf != None:
		self.toolbar.add_default_conf(self.user_current_conf,
					      komtext.safe_name_nolink(
						  session,
						  self.user_current_conf))
		return

	    # No cookie given, so try to figure out a good default
	    # action and set a cookie.
	    log.debug("No cookie detected by fix_default; will set one")
		
	prompt = session.next_prompt()
	cookie = None
	while prompt == 6:
	    prompt = session.next_prompt()
	log.debug("Next prompt: " + `prompt`
		  + " Current conf: " + `session.current_conf()`
		  + " user: " + `self.user_current_conf`)
	if prompt == 1:
	    # Next conf
	    cno = session.query_next_conf()
	    if cno != 0:
		self.toolbar.add_default_conf(
		    cno,
		    komtext.safe_name_nolink(session, cno))
		cookie = `cno` + ":::"
	    else:
		log.err("Internal error detected in set_unread_cookie")
	elif prompt == 5:
	    # Nothing to do
	    cookie = `session.current_conf()` + ":::"
	    self.toolbar.add_default_time()
	else:
	    # Something to do.
	    tno = session.next_text()
	    if prompt == 2:
		self.toolbar.add_default_text(tno)
	    elif prompt == 3:
		self.toolbar.add_default_comment(tno)
	    elif prompt == 4:
		self.toolbar.add_default_footnote(tno)
	    else:
		log.err("Read-order error " + `prompt`
			+ "detected in set_unread_cookie.")
	    footnotes = self.intstoxlist(session.get_pending_footnotes())
	    comments = self.intstoxlist(session.get_pending_comments())
	    cookie = `session.current_conf()` + ":" + `tno` + ":" \
		     + footnotes + ":" + comments
	if cookie == None:
	    log.err("Cookie not set by fix_default")
	else:
	    self.cookies.append(("LysKOM_www_readorder", cookie))

    def kom_GET_conf(self, args):
	cno = args.getnum("conf_no")
	if cno == None:
	    raise komhtml.not_a_komurl, "no conf_no to /conf"
	self.kom_get_conf(cno)

    def kom_get_conf(self, cno):
	# FIXME: config
	texts_to_display = 20
	texts_to_prefetch = texts_to_display + 1
	conf=session.conf(cno)
	if session.goto_conf(cno) != komxx.st_ok:
	    # FIXME: better error message
	    raise komhtml.not_a_komurl, "Couldn't go to the conf"

	# Prefetch information for the list.
	# FIXME: I want to exit the loop as soon as all prefetch
	# questions have been issued, even if some have not yet
	# returned.
	while session.prefetch(0, texts_to_prefetch, 1, \
			       0, texts_to_prefetch, 1, \
			       40) == komxx.st_pending:
	    session.block(1000)

	unread_list = ""
	unread=session.list_unread_texts_in_current(texts_to_display + 1)
	unprefetched_authors=[]
	for (text, level) in unread:
	    komtext.prefetch_author(session, session.text(text),
				    unprefetched_authors)
	for t in unprefetched_authors:
	    if t.exists():
		session.conf(t.author()).prefetch_name()

	# Format the list of unread texts.
	prev_level = -1
	prev_subject = ""
	for (text, level) in unread:
	    while prev_level < level:
		prev_level = prev_level + 1
		unread_list = unread_list + "<ul>\n"
	    while prev_level > level:
		prev_level = prev_level - 1
		unread_list = unread_list + "</ul>\n"
	    t = session.text(text)
	    subject = t.subject()
	    unread_list = unread_list + "<li>" + lingo.text_link(
	       komhtml.text_as_link(text),
	       subject, prev_subject, komtext.safe_author(session, text))
	    prev_subject = subject
	while prev_level > -1:
	    prev_level = prev_level - 1
	    unread_list = unread_list + "</ul>\n"
	self.fix_default(1)
	self.toolbar.add_write(cno)
	# FIXME: check if there are more unread.
	# FIXME: Swedish!  Be gone!
	self.respond(lingo.page("Olsta",
				"Olsta i " + komtext.safe_name(session, cno),
				"Dessa texter r olsta: " + unread_list))

    def kom_GET_comment(self, args):
	tno = args.getnum("parent")
	if tno == None:
	    raise komhtml.not_a_komurl, "missing argument parent to /comment"
	text=session.text(tno)
	text.prefetch()
	#
	# Prefetch everything needed to comment text TEXT
	#
	author=session.conf(text.author())
	author.prefetch_name()
	for rcpt in text.recipients():
	    if not rcpt.is_carbon_copy():
		session.conf(rcpt.recipient()).prefetch()
	#
	# Prepare the page
	#
	map = komtext.create_comment_map(session, tno)
	if session.current_conf() != 0:
	    self.toolbar.add_current_conf(session.current_conf())
	    self.toolbar.add_write(session.current_conf())
	self.respond(lingo.write_comment(map))

    def kom_GET_write_text(self, args):
	cno = args.getnum("conf_no")
	if cno == None:
	    raise komhtml.not_a_komurl, "missing arg conf_no to /write_text"
	conf=session.conf(cno)
	conf.prefetch()
	#
	# Prepare the page
	#
	map = komtext.create_text_map(session, [cno])
	self.toolbar.add_default_conf(cno,
				      komtext.safe_name_nolink(session, cno))
	self.respond(lingo.write_text(map))

    def kom_GET_submit_text(self, args):
	i = args.getnum("no_of_rcpts")
	if i == None:
	    raise komhtml.not_a_komurl, "missing no_of_rcpts in /submit_text"
	recipients=[]
	while i > 0:
	    i = i - 1
	    rcpt_tmp = args.getnum("rcpt" + `i`)
	    if rcpt_tmp != None:
		recipients.append(rcpt_tmp)
	# FIXME: can only handle a single comment-to or footnote-to link.
	comment_list = []
	footnote_list = []
	comment_to = args.getnum("parent")
	footnote_to = args.getnum("parent_footnote")
	t = None
	if comment_to != None:
	    t = session.text(comment_to)
	    comment_list = [comment_to]
	elif footnote_to != None:
	    t = session.text(footnote_to)
	    footnote_list = [footnote_to]
	if t != None:
	    comments = pickle.loads(args.getstr_empty("known_comments"))
	    new_comments = []
	    current_comments = t.comments_in() + t.footnotes_in()
	    for c in current_comments:
		if c not in comments and c not in new_comments:
		    new_comments.append(c)
	    if len(new_comments) > 0:
		new_comments.sort()
		for c in new_comments:
		    komtext.prefetch_for_display(session, session.text(c))
		new_texts=[]
		for c in new_comments:
		    map = komtext.map_for_display(session, session.text(c))
		    new_texts.append(lingo.format_text(map))
		map = komtext.recreate_comment_map(
		   session, args, current_comments, recipients)
		self.fix_default()
		self.respond(lingo.new_texts_exists(new_texts, map))
		return
	body = regsub.gsub('\r', ' ', args.getstr_empty("body"))
	subject = args.getstr_empty("subject")
	conv = args.getstr("conversion")
	if conv != None:
	    body = do_convert(conv, body)
	    subject = do_convert(conv, subject)

	tno = session.create_text(subject, body, recipients, [],
				  comment_list, footnote_list)
	# Alt 1:
	# self.fix_default()
	# session.text[tno].mark_as_read()
	# self.respond(lingo.text_created(tno))

	# Alt 2:
	# self.kom_get_text(tno)

	# Alt 3:
	self.send_redirect(komhtml.komurl("text?text_no=" + `tno`))
	
    def kom_GET_kill(self, args):
	self.respond(lingo.killed())
	sys.stdout.flush()
	sys.stderr.flush()
	self.wfile.flush()
	signal.alarm(1)

    def kom_GET_select_conf_form(self, args):
	self.respond(lingo.select_conf_form())

    def kom_GET_submit_select_conf(self, args):
	domain = args.getstr_empty("domain")
	search_conf = 0
	search_pers = 0
	if domain == "conf":
	    search_conf = 1
	elif domain == "pers":
	    search_pers = 1
	elif domain == "both":
	    search_conf = 1
	    search_pers = 1
	else:
	    search_conf = 1
	matches = session.lookup_z_name(args.getstr_empty("conf_name"),
					search_pers, search_conf)
	if len(matches) == 1:
	    return self.kom_get_conf_stat(matches[0].conf_no())
	else:
	    self.respond(lingo.list_conf(matches))

    def kom_GET_conf_stat(self, args):
	cno = args.getnum("conf_no")
	if cno == None:
	    raise komhtml.not_a_komurl, "missing conf_no to /conf_stat"
	self.kom_get_conf_stat(cno)

    def kom_get_conf_stat(self, cno):
	conf = session.conf(cno)
	map = {}
	map["name"] = komtext.safe_name(session, cno)
	map["name_nolink"] = komtext.safe_name_nolink(session, cno)
	map["conf_no"] = cno
	map["creator"] = komtext.safe_name(session, conf.creator())
	map["supervisor"] = komtext.safe_name(session, conf.supervisor())
	# FIXME: swedish detected below! Move to language.py!
	if conf.permitted_submitters() == 0:
	    psub = "Alla"
	else:
	    # FIXME: doesn't this lack a space?
	    psub = ("Medlemmar i" 
		    + komtext.safe_name(session, conf.permitted_submitters()))
	map["permitted_submitters"] = psub
	map["presentation"] = komhtml.text_as_link(conf.presentation())
	if session.is_member(session.my_login(), cno):
	    map["join"] = None
	    map["limit_unread"] = komhtml.komurl("limit_unread")
	else:
	    map["join"] = komhtml.komurl("join?conf_no=" + `cno`)
	    map["limit_unread"] = None
	map["write_text"] = komhtml.komurl("write_text?conf_no=" + `cno`)
	self.toolbar.add_current_conf(cno)
	self.toolbar.add_write(cno)
	self.fix_default()
	self.respond(lingo.conf_stat(session.my_login(), map))

    def kom_GET_join(self, args):
	cno = args.getnum("conf_no")
	if cno == None:
	    raise komhtml.not_a_komurl, "missing conf_no arg to /join"
	# FIXME: correct level and placement?
	session.join_conference(cno, 100, 1)
	self.kom_GET_conf(args)

    def kom_GET_who_is_on(self, args):
	wholist = session.who_is_on()

	cno = args.getnum("conf_no")

	# Prefetch the name for the person and his working conference
	for w in wholist:
	    if cno == None or w[1] == cno:
		session.conf(w[0]).prefetch_name()
		session.conf(w[1]).prefetch_name()

	wholist2 = []
	for w in wholist:
	    if cno == None or w[1] == cno:
		perslink = komtext.safe_name(session, w[0])
		if w[1] == 0:
		    confname = lingo.not_present()
		else:
		    confname = komtext.safe_name(session, w[1])

		if w[2] == session.my_session():
		    item = ("<tr valign=top>" 
			    + "<td><b>" + `w[2]` 
			    + "</b><td><b>" + perslink
			    + "</b><td><b>" + confname
			    + "</b></tr>")
		else:
		    item = ("<tr valign=top>" 
			    + "<td>" + `w[2]` 
			    + "<td>" + perslink
			    + "<td>" + confname
			    + "</tr>")
		wholist2.append(item)

	self.fix_default()
	if cno == None:
	    self.respond(lingo.who_is_on(wholist2))
	else:
	    self.respond(lingo.who_is_on_conf(komtext.safe_name(session,cno),
					      wholist2))

    def kom_GET_set_unread(self, args):
	cno = args.getnum("conf_no")
	days = args.getnum("unread_days")
	txts = args.getnum("unread_texts")
	if cno == None:
	    raise komhtml.not_a_komurl, "Missing arg conf_no to /set_unread"
	if (days == None and txts == None) or (days != None and txts != None):
	    self.respond(lingo.set_unread_need_one())

	if days != None:
	    timeval = time.localtime(time.time() - 86400 * days)
	    timeval = (timeval[0], timeval[1], timeval[2], 0, 0, 0,
		       timeval[6], timeval[7], timeval[8])
	    lno = session.last_local_before(cno, timeval)
	else:
	    conf = session.conf(cno)
	    lno = conf.first_local_no() + conf.no_of_texts() - txts;
	session.set_last_read(cno, lno)
	self.kom_get_conf(cno)

def do_convert(conversion, str):
    if conversion == "swascii":
	str = regsub.gsub('}', '', str)
	str = regsub.gsub('{', '', str)
	str = regsub.gsub('|', '', str)
	str = regsub.gsub(']', '', str)
	str = regsub.gsub('\[', '', str)
	str = regsub.gsub('\\\\', '', str)
    return str

def detach():
    global syncw

    if os.getppid() != 1:
	try:
	    signal.signal(signal.SIGTTOU, signal.SIG_IGN)
	except:
	    pass
	try:
	    signal.signal(signal.SIGTTIN, signal.SIG_IGN)
	except:
	    pass
	try:
	    signal.signal(signal.SIGTSTP, signal.SIG_IGN)
	except:
	    pass

	(syncr, syncw) = os.pipe()

	child = os.fork()
	if child < 0:
	    log.err("fork failed")
	    sys.exit(1)
	elif child > 0:
	    os.close(syncw)
	    os.read(syncr, 1)
	    os._exit(0)	# parent
	
	# child
	os.close(syncr)

	try:
	    os.setsid()
	except:
	    pass

def start_httpd():
    global session
    global state
    for port in range(8000, 8500):
	try:
	    httpd = myserver.myserver(('', port), sh)
	    print "Port:", port
	    sys.stdout.flush()
	    log.debug("...reading Person:")
	    pers_no = string.atoi(estring.read_word(sys.stdin, "Person:"))
	    log.debug("...got " + `pers_no`)
	    log.debug("...reading Password:")
	    state.password = base64.decodestring(estring.read_word(
		    sys.stdin, "Password:"))
	    log.debug("...got something")
	    try:
		session = komxx.new_session(sys.argv[1], sys.argv[2])
		if session.login(pers_no, state.password) == komxx.st_ok:
		    print "Login OK"
		    sys.stdout.flush()
		else:
		    # FIXME: need a way to get the error code!
		    # This should return different error messages
		    # depending on what went wrong.
		    print "Bad password"
		    sys.stdout.flush()
		    log.notice("Bad start-up password or user; exiting")
		    os.write(syncw, "X")
		    sys.exit(1)
		    
	    except komxx.no_connection:
		print "Connection refused"
		sys.stdout.flush()
		log.notice("Failed to connect to LysKOM server at "
			   + sys.argv[1] + ":" + sys.argv[2])
		os.write(syncw, "X")
		sys.exit(1)

	    log.debug("closing everything")
	    log.close()
	    for i in range(3):
		try:
		    os.close(i)
		except:
		    pass

	    # FIXME: nothing should write to these files, but several
	    # things does.  Remove these files when nothing writes to them.

	    f=open("/tmp/wwwkomserver." + `os.getpid()` + ".out", "w")
	    os.dup2(f.fileno(), 0)
	    os.dup2(f.fileno(), 1)
	    os.dup2(f.fileno(), 2)
	    log.init("sc")
	    log.debug("everything is closed")
	    break
	except socket.error:
	    # Try next port in the range
	    pass
    return httpd

def test():
    global syncw

    try:
	log.init("sc")
	log.notice("SC starting")

	detach()
	# FIXME: use getopt
	if len(sys.argv) > 3 and sys.argv[3] == "tell_pid":
	    print "Pid:", os.getpid()
	    sys.stdout.flush()

	httpd = start_httpd()
	os.write(syncw, "X")
	httpd.serve_forever()
    finally:
	log.notice("SC exiting")

if __name__ == '__main__':
    test()
